#ifndef SARY
typedef struct  s_sary {int len, total; char *(*ary)[];} Sary;
#define  SARY true
#endif

void s_readtrim(Sary *bf, char *file);
void s_read_max(Sary *bf, char *file, int max);
void s_wild(Sary *bf, char *path, char *wild);
Sary *s_alloc(void);
char *s_line(Sary *bf, int n);
int s_len(Sary *bf);
int s_add(Sary *bf, char *s);
void s_set(Sary *bf, int n, char *s);
void s_check(Sary *bf);
void s_clear(Sary *bf);
void s_free(Sary *bf);
void s_grow(Sary *bf, int sz);
void s_init(Sary *bf);
void s_print(Sary *bf);
void s_read_secure(Sary *bf, char *file);
void s_read(Sary *bf, char *file);
void s_write(Sary *bf, char *file);
void s_read_long(Sary *bf, char *file);
void s_read_sz(Sary *bf, char *file, int sz);
